use bson::Document;
use serde::{Serialize};
use serde::de::DeserializeOwned;

pub trait BsonSerializable
    where Self: Sized+Serialize+DeserializeOwned
{
    fn to_document(&self) -> Document {
        let it = self.clone();
        bson::to_document(it).unwrap()
    }

    fn from_document(doc: &Document) -> Self {
        bson::from_document(doc.clone()).unwrap()
    }
}