#[macro_export]
macro_rules! to_doc_gen {
    ($visibility:vis struct $name:ident {$(pub $field_name:ident : $field_type:ty), *}) => {
        #[derive(Debug, Deserialize, Serialize)]
        $visibility struct $name {
            $(pub $field_name: $field_type,)*
        }
        impl $name {
            pub fn to_document(&self) -> Document {
                let it = self.clone();

                return doc!{
                    $(stringify!($field_name): it.$field_name.to_string(),)*
                }
            }
        }
    };
}