#[macro_export]
macro_rules! obj_to_json_resp {
    ($($field_name:ident : $field_type:ty = $field_val:expr), *) => {


        {
            #[derive(Debug, ::serde::Deserialize, ::serde::Serialize)]
            struct TempJsonObj {
                $(pub $field_name: $field_type),*
            }
            impl TempJsonObj {
                pub fn new($($field_name : $field_type),*) -> Self {
                    TempJsonObj {
                        $($field_name),*
                    }
                }
            }
            let temp_json_obj_inst = TempJsonObj::new(
                $($field_val),*
            );
            HttpResponse::Ok().content_type("application/json").json(temp_json_obj_inst)
        }


    };
}