use actix_web::{HttpResponse, HttpResponseBuilder};
use serde::Serialize;
use crate::api::request_error::RequestError;
use crate::api::request_success::RequestSuccess;

pub fn response_error(mut builder: HttpResponseBuilder, msg: &str) -> HttpResponse {
    builder.content_type("application/json").json(RequestError::new(msg))
}

pub fn response_msg(msg: &str) -> HttpResponse {
    HttpResponse::Ok().content_type("application/json").json(RequestSuccess::new(msg))
}

pub fn response_json<T: Serialize>(val: T) -> HttpResponse {
    HttpResponse::Ok().content_type("application/json").json(val)
}