use crate::model::version::Version;
use serde::{Deserialize, Serialize};

#[derive(Debug, Deserialize, Serialize)]
pub struct App {
    id: String,
    attraction_type: String,
    max_players: u8,
}

#[derive(Debug, Deserialize, Serialize)]
pub enum RemoteAppType {
    ManagementSystemServer,
    ManagementSystemAgent,
    Game,
}

#[derive(Debug, Deserialize, Serialize)]
pub struct RemoteApp {
    app_type: RemoteAppType,
    version: Version,
}
