use serde::{Deserialize, Serialize};
use crate::auxiliary::bson_serializable::BsonSerializable;


#[derive(Clone, Debug, Deserialize, Serialize)]
pub struct ControllerAlias {
    pub serial_number: String,
    pub alias: String,
}

impl ControllerAlias {
    pub fn new(serial_number: String, alias: String) -> Self {
        Self {
            serial_number,
            alias,
        }
    }

    pub fn new_full(serial_number: String, alias: String) -> Self {
        Self {
            serial_number,
            alias,
        }
    }
}

impl BsonSerializable for ControllerAlias {}