use uuid::Uuid;
use std::{collections::HashMap, time::SystemTime};
use serde::{Serialize, Deserialize};

#[derive(Debug, Deserialize, Serialize, Clone)]
pub struct LaunchParameters {
    pub server_ip_port: Option<String>,
    pub session_id: Option<Uuid>,
    pub program: String,
    pub args: Vec<String>,
    pub working_dir: Option<String>,
    pub environment_vars: Option<HashMap<String,String>>,
    pub callback_link: Option<String>
}

#[derive(Clone,Debug, Deserialize)]
pub struct Process {
    launch_parameters: LaunchParameters,
    uuid: Uuid,
    created_at: SystemTime,
}
