use futures::TryStreamExt;
use mongodb::bson::{doc, Document};
use mongodb::Collection;
use crate::crud;
use crate::model::controller_alias::ControllerAlias;
use crate::auxiliary::bson_serializable::BsonSerializable;


#[derive(Clone, Debug)]
pub struct ControllerAliasRepo {
    col: Collection<Document>
}

impl ControllerAliasRepo  {
    pub fn new(col: Collection<Document>) -> Self {
        ControllerAliasRepo {col}
    }
}

impl ControllerAliasRepo {
    crud!(add, ControllerAlias);
    crud!(get_all, ControllerAlias);
    crud!(update, ControllerAlias, alias_by_serial_number, serial_number: &str = serial_number.to_string(); alias: &str = alias.to_string());
}