enum Token {
    Index,
    Plus,
    Minus,
    Multiply,
    OpenBracket,
    CloseBracket,
    Digit(u32),
    Error(char)
}

struct AST {

}

fn lex(input: String) -> Result<Vec<Token>, Token>{
    let mut res = Vec::new();
    for c in input.chars() {
        let token = identify_symbol(c);
        if let Token::Error(_) = token {
           return Err(token)
        }
        res.push(token);
    }
    Ok(res)
}

fn identify_symbol(c: char) -> Token {
    return match c {
        'i' => Token::Index,
        '+' => Token::Plus,
        '-' => Token::Minus,
        '*' => Token::Multiply,
        '(' => Token::OpenBracket,
        ')' => Token::CloseBracket,
        '0' | '1' | '2' | '3' | '4' | '5' | '6' | '7' | '8' | '9' => Token::Digit(c.to_digit(10).unwrap()),
        _ => Token::Error(c)
    }
}

fn parse(tokens: Vec<Token>) {

}