let args_container = document.getElementById('arguments');
let env_container = document.getElementById('envs');

const arg_el_name  = 'arg';
const env_el_name  = 'env'

const arg_placeholder = "Argument";
const envK_placeholder = "EKey";
const envV_placeholder = "EVal";

function load_from_storage(device_id, configuration_id) {
	let data = load_device_storage(device_id, configuration_id);
	if (!data) {
		console.log(data);
		return;
	}

	for (const e of data['args']) {
		console.log(e);
		add_arg(e);
	}
	for (const [k,v] of Object.entries(data['env'])) {
		add_env(k,v);
	}

}

function add_arg(val) {
	let el = document.createElement('div');
	el.innerHTML = `<input class="form-control" type="text" name="${arg_el_name}" placeholder="${arg_placeholder}" minlength="4" maxlength="100" size="100">`
	let d = el.getElementsByTagName('input')[0];
	d.value = val;
	args_container.appendChild(el);
}

function add_env(k_val, v_val) {
	let el = document.createElement('div');	
	el.innerHTML = `<div class="form-row" name="${env_el_name}">
	<div class="col-sm-3 my-1" >
	<input class="form-control" type="text" name="K" placeholder="${envK_placeholder}"
    minlength="3" maxlength="100" size="100">
	</div>
    <div class="col-sm-3 my-1">
	<input class="form-control" type="text" name="V" placeholder="${envV_placeholder}"
	       minlength="3" maxlength="100" size="100">
    </div>
    </div>`
	let d = el.getElementsByTagName('input');
	d[0].value = k_val;
	d[1].value = v_val;

	env_container.appendChild(el)
}

function data_to_obj(arg_el, group_el) {
	let _elements = document.getElementsByName(arg_el);
	let elements = [];
	for (let e of _elements.values()) {
		elements.push(e.value)
	}

	let _groups_kv = document.getElementsByName(group_el);
	let kvs = {};
	for (let e of _groups_kv.values()) {
		let items = e.getElementsByTagName("input")
		if (items[0].value == '') {
			continue;
		}
		kvs[items[0].value] = items[1].value
	}
	return {
		'args' : elements,
		'env': kvs
	}
}

function run_app_with_parameters(arg_el, group_el, device_id, configuration_id) {
	let req = "/runner/run/device";
	let err_msg = "Something wrong"
	let obj = data_to_obj(arg_el, group_el);

	obj['identifier'] =  {id: device_id}
	obj['configuration'] = {id: configuration_id}
	console.log(obj['args'])
	save_device_data(device_id, configuration_id, obj['args'], obj['env']);
	make_json_request(POST, req, obj)
		.then(e => {
			if(!e.ok){
				alert(err_msg)
			}
		});
}

