function add_element_to_form(groupId, new_el) {
    let el = document.createElement('div');
    el.innerHTML = new_el;
    document.getElementById(groupId).appendChild(el)
}

function add_element_key_value_to_form(groupId, new_el) {
    let el = document.createElement('div');
    el.innerHTML = new_el;
    document.getElementById(groupId).appendChild(el);
    return el;
}

function add_element_key_value_to_form_with_val(groupId, new_el, id, key, val) {
    let e = add_element_key_value_to_form(groupId, new_el);
    
    let inputs = e.getElementsByTagName("input");
    inputs[0].value = key;
    inputs[1].value = val;
    let select = e.getElementsByTagName("select");
    select[0].value = id;
}

function add_element_to_form_with_val(groupId, new_el, id, val) {
    let e = add_element_key_value_to_form(groupId, new_el);
    
    let inputs = e.getElementsByTagName("input");
    inputs[0].value = val;
    let select = e.getElementsByTagName("select");
    select[0].value = id;
}


function data_to_obj(arg_el, group_el) {
    let _elements = document.getElementsByName(arg_el);
    let args = {};
    for (let e of _elements.values()) {
        let inputs = e.getElementsByTagName("input")
        let value = inputs[0].value
	if (value == '') {
	  continue;
	}
        let device_type = e.getElementsByTagName("select")[0].value

        if(device_type in args) {
            args[device_type].push(value)
        }
        else {
            args[device_type] = [value]
        }

    }

    let _groups_kv = document.getElementsByName(group_el);
    let envs = {};
    for (let e of _groups_kv.values()) {
        let inputs = e.getElementsByTagName("input")
        let key_env = inputs[0].value
        let value_env = inputs[1].value

	if (key_env == '') {
	  continue;
	}
        let device_type = e.getElementsByTagName("select")[0].value

        if(device_type in envs) {
            envs[device_type][key_env] = value_env
        }
        else {
            envs[device_type] = {}
            envs[device_type][key_env] = value_env
        }
    }
    return {
        'args' : Object.entries(args).map(e => [{id: e[0]}, e[1]]),
        'env': Object.entries(envs).map(e => [{id: e[0]}, e[1]])
    }
}
