function getColumn(selector, column) {
    let rows = document.querySelector(selector).getElementsByTagName('tr');
    return [].slice.call(rows).map(function(tr) {
        return tr.getElementsByTagName('td')[column].innerText;
    });
}

function update_device_state(id, new_state){
    let element = document.getElementById(`state_${id}`);
    console.log(new_state)
    element.innerText = new_state;
    update_device_bridge(id);
}

function update_device_bridge(device_id) {
    // WELCOME TO WONDERFUL JS WORLD!!!
    fetch("/check_update", {
        method: "POST",
        cache: "no-cache",
        headers: {
            'Content-Type': 'application/json'
        },
        body: JSON.stringify({device_id: device_id})
    })
        .then(e => e.json())
        .then(e => {
            let state = document.getElementById(`state_${device_id}`).innerText;
            let badge = document.getElementById(`badge_${device_id}`);
            if (state == "Unavailable") badge.hidden = true;
            else badge.hidden = !e;
        })
}

function print_all_connected_devices() {
    device_ids.forEach(id => {
        fetch("/connections/check", {
            method: "POST",
            cache: "no-cache",
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({id: id})
        })
            .then(e => e.json())
            .then(e => update_device_state(id, e.device_state))
    })
}

setInterval(print_all_connected_devices, 10000);