function append_new_form_row(container, htmlString) {
    const elm = document.createElement('div');
    elm.innerHTML = htmlString.trim();
    elm.querySelector('button').onclick = (event) => { event.target.parentElement.parentElement.parentElement.remove(); }
    container.appendChild(elm);
}


function remove_all_options(select) {
    let ops = select.options;
    while (ops.length > 0) {
        ops.remove(0);
    }
}


function extend_options(select, options) {
    let ops = select.options;

    options.forEach(x => {
        let elm = document.createElement("option");
        for (let key in x) {
            elm[key] = x[key];
        }
        elm.value = x.uid;
        elm.text = `${x.name} : ${x.uid}`;
        ops.add(elm);
    })
}


function read_minimal_necessary_devices(form) {
    let minimal_necessary_devices = {};
    form.querySelectorAll("#minimal_necessary_devices_container .form-row").forEach(x => {
        a = x.querySelector('select[name="device_type"');
        b = x.querySelector('input[name="device_count"');
        minimal_necessary_devices[a.value] = parseInt(b.value);
    });
    return minimal_necessary_devices;
}


function read_configurations(form) {
    let configurations = {};
    form.querySelectorAll("#configurations_container .form-row").forEach(x => {
        a = x.querySelector('select[name="device_type"');
        b = x.querySelector('select[name="device_configuration"');
        configurations[a.value] = b.value;
    });
    return configurations;
}


function read_need_sync(form) {
    let configurations = read_post_sync_configurations(form);
    return Object.keys(configurations).length !== 0;
}


function read_post_sync_configurations(form) {
    let configurations = {};
    form.querySelectorAll("#post_sync_configurations_container .form-row").forEach(x => {
        a = x.querySelector('select[name="post_sync_device_type"');
        b = x.querySelector('select[name="post_sync_device_configuration"');
        configurations[a.value] = b.value;
    });
    return configurations;
}


function reset_minimal_necessary_devices(form) {
    form.querySelectorAll("#minimal_necessary_devices_container .form-row").forEach(elm => elm.remove());
}

function reset_configurations(form) {
    form.querySelectorAll("#configurations_container .form-row").forEach(elm => elm.remove());
}



function set_onsubmit_event(ip_port) {
    let err_msg = "Something wrong"
    let req = "/admin/types/attraction/new"

    let form = document.getElementById('new_attraction_form');
    form.onsubmit = function (event) {

        obj = {
            name: document.getElementById("device_name").value,
            minimal_necessary_devices: read_minimal_necessary_devices(form),
            configurations: read_configurations(form),
            need_sync: read_need_sync(form),
            post_sync_configurations: read_post_sync_configurations(form)
        }

        make_json_request(POST, req, obj)
            .then(e => {
                if (!e.ok) {
                    alert(err_msg)
                }
                else {
                    form.reset();
                    reset_minimal_necessary_devices(form);
                    reset_configurations(form);
                }
            })

        return false;
    }

}