buttons = document.getElementsByName("disabled")
buttons.forEach((v) => v.addEventListener("click", function(){
    add_elem(v);
}))

document.getElementById("run_attraction").addEventListener("click", run_attraction)

function add_elem(elem) {
    if (elem.name === "disabled") {

        //Table line
        elem.parentElement.parentElement.style.background = "rgba(34,194,68,0.44)";
        elem.innerText = ""
        elem.name = "enabled"
        elem.innerHTML =
            `
            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-check" viewBox="0 0 16 16">
            <path d="M10.97 4.97a.75.75 0 0 1 1.07 1.05l-3.99 4.99a.75.75 0 0 1-1.08.02L4.324 8.384a.75.75 0 1 1 1.06-1.06l2.094 2.093 3.473-4.425a.267.267 0 0 1 .02-.022z"/>
            </svg>
            `
    }
    else{
        elem.parentElement.parentElement.style.background = "";
        elem.name = "disabled"
        elem.innerHTML = ""
        elem.innerText = "+"
    }
}

function run_attraction() {
    const args_env = data_to_obj("arguments", "env");
    save_elements_to_storage();
    let ids = []
    for (const x of document.getElementsByName("enabled")){
        ids.push({
            id: x.id.split("_")[1]
        })
    }

    const attraction = {
        attraction: {
            id: att_id
        },
        device_ids: ids,
        args: args_env.args,
        environment: args_env.env
    }

    console.log(attraction)

    fetch("/runner/run/attraction", {
        method: "POST",
        cache: "no-cache",
        headers: {
            'Content-Type': 'application/json'
        },
        body: JSON.stringify(attraction)
    })
        .then((res) => {
            if (res.ok) { window.location.href = "/admin" }
            else { alert(`Failed to run attraction (${res.statusText})`) }
        })
}

function save_elements_to_storage() {
  const args_env = data_to_obj("arguments", "env");
  const args = args_env.args;
  const env  = args_env.env;
  
  localStorage.setItem(att_id + "_args", JSON.stringify(args))
  localStorage.setItem(att_id + "_env", JSON.stringify(env))
}

function load_elements_from_storage() {
  const arg_p = localStorage.getItem(att_id + "_args") 
  const env_p = localStorage.getItem(att_id + "_env")
  if (env_p === null || arg_p === null) {
    return;
  }
  const args = JSON.parse(arg_p)
  const env  = JSON.parse(env_p)

  for(const e of args) {
  const aid = e[0].id
  e[1].forEach((c) => {add_element_to_form_with_val("arguments", new_line_arg, aid, c) })
  }

  for(const e of env) {
  const eid = e[0].id
  for (const [key, value] of Object.entries(e[1])) {
    add_element_key_value_to_form_with_val("envs", new_line_env, eid, key, value)
  }
  }
}

